/*
 * DIMException.h
 *
 *  Created on: Oct 13, 2014
 *      Author: mdonze
 */

#ifndef DIMEXCEPTION_H_
#define DIMEXCEPTION_H_

#include <string>

namespace ntof {
namespace dim {
/**
 * Represents an exception generated by DIM
 */
class DIMException : public std::exception
{
public:
    /**
     * Constructs this
     * @param Msg Error message
     * @param Line Line of code doing the error (__LINE__)
     */
    DIMException(const std::string &Msg, int Line, int error = 0);

    /**
     * Construct this
     * @param Msg Error message
     * @param Line Line of code doing the error (__LINE__)
     * @param error Error code
     */
    DIMException(const char *Msg, int Line, int error = 0);

    /**
     * Destroy this
     */
    virtual ~DIMException() = default;

    /**
     * Overload of std::exception
     * @return Error message
     */
    virtual const char *what() const noexcept;

    /**
     * Gets the error message
     * @return The error message
     */
    inline const char *getMessage() const noexcept { return msg.c_str(); }

    /**
     * Gets the error code
     * @return
     */
    inline int getErrorCode() const noexcept { return errorCode; }

protected:
    mutable std::string m_what;
    std::string msg; //!< Error message
    int line;        //!< Line of the error
    int errorCode;   //!< Error code
};
} // namespace dim
} // namespace ntof

#endif /* DIMEXCEPTION_H_ */
